/************************************************************************/
/*       C-file to part 3 of Abe's Demoschool, picture & sprite         */
/*                                                                      */
/* The program allocates a virtual screen, then a picture  is read from */
/* disk to the virtual screen. The picture is flipped over to the       */
/* visible screen using a dissolve effekt.                              */
/*                                                                      */
/* All drawing is made to the virtual screen, when the drawing is       */
/* finished the virtual screen is flipped to the                        */
/* visible screen and appears.                                          */
/*                                                                      */
/*      The main loop does the following:                               */
/*                                                                      */
/* 1    save the background where the sprite will be drawn              */
/* 3    Waits for the vertical retrace and flips the virtual screen     */
/*      over to the visible screen                                      */ 
/* 5    If no button has been pressed, jump to one                      */
/*                                                                      */
/*      1996-01-17                                                      */
/*      Sir Abe                                                         */
/*      electronic mail:        dat94avi@bilbo.mdh.se                   */
/*      snail mail:             Albert Veli                             */
/*                              Spisringsg. 9                           */
/*                              724 76 Vsters                         */
/*                                                                      */                                
/************************************************************************/
/* char far* means an array that can be outside of the current segment  */
/* the program includes no libraries like stdio.h or stdlib.h           */
/* they only make the .exe unnecessary big                              */
/* the code for these functions is in asmdemo3.asm                      */
/* You could keep these extern-declarations in a separate .h file       */
/* I don't because It's enough files already in this part of the demoschool */


extern int loadpalett(char far*name,char far*pal);
extern int showpic(int x,int y,char far*name,char far*dest);
extern void erase32bit(int x, int y, int width, int height, char far*dest);
extern void getback32(int x,int y,int width,int height,char far*source,char far*dest);
extern char getch(void);
extern void setmode(int mode);
extern void setpal(char far*pal);
extern void flip64k(char far*source, char far*dest);
extern void disflip64k(char far*source, char far*dest);
extern void disflipblack(char far*source, char far*dest);
extern char far*malloc(unsigned int nr_of_bytes);
extern int free(char far*memoryblock);
extern void wtsync(void);
extern char kbhit(void);

void main(void)
{
char far*virt;
char far*screen;
char pal[3*256];

screen=0x0a0000000;  //this gives a warning but it works (on my compiler :-))

virt=malloc(64000);             //allocate 64000 bytes for a virtual screen
if(virt!=0)                     //if it worked, go on

{
	erase32bit(0,0,320,200,virt);   /* clear virt */
	showpic(0,0,"lens.pic",virt);    /* show a picture on virt */
	setmode(0x0013);                /* enter mode 13h */
	loadpalett("palett.col",pal);   /* load the palette */
	setpal(pal);                    /* set the palette */

	do
	{
		wtsync();                       /* wait for vertical retrace */
		flip64k(virt,screen);           /* flip virt to screen */

	}while(!kbhit());

	erase32bit(0,0,320,200,virt);  /* erase virt (make it black) */
	disflip64k(virt,screen); /* dissolveflip black virt over to the screen */
	setmode(3);                     /* get back into textmode */
	free(virt);              /* return the allocated memory for virt */
}
else ;
//print an error message here (out of memory or something like that)
//I didn't because I haven't written any text-functions for this part of
// the demoschool. There's enough functions as it is now . . .
}
